/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLElement_H__
#define __GdomHTMLElement_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomElement.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLElement GdomHTMLElement;
typedef struct _GdomHTMLElementClass GdomHTMLElementClass;


#define GDOM_TYPE_HTML_ELEMENT            (gdom_html_element_get_type())
#define GDOM_HTML_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_ELEMENT, GdomHTMLElement))
#define GDOM_HTML_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_ELEMENT, GdomHTMLElement)Class)
#define GDOM_IS_HTML_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_ELEMENT))
#define GDOM_IS_HTML_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_ELEMENT))
#define GDOM_HTML_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_ELEMENT, GdomHTMLElementClass))

typedef struct _GdomHTMLElementPrivate GdomHTMLElementPrivate;

struct _GdomHTMLElement {
    GdomElement parent_instance;
    GdomHTMLElementPrivate *priv;
};

struct _GdomHTMLElementClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_element_get_type (void);

WEBKIT_API void
gdom_html_element_blur (GdomHTMLElement *thiz);

WEBKIT_API void
gdom_html_element_focus (GdomHTMLElement *thiz);

WEBKIT_API GdomElement *
gdom_html_element_insert_adjacent_element (GdomHTMLElement *thiz, gchar * where, GdomElement * element);

WEBKIT_API void
gdom_html_element_insert_adjacent_html (GdomHTMLElement *thiz, gchar * where, gchar * html);

WEBKIT_API void
gdom_html_element_insert_adjacent_text (GdomHTMLElement *thiz, gchar * where, gchar * text);

G_END_DECLS

#endif /* __GdomHTMLElement_H__ */
